diff --git a/src/win.c b/src/win.c
index a7c547de..8979a2e7 100644
--- a/src/win.c
+++ b/src/win.c
@@ -1883,10 +1883,12 @@ bool destroy_win_start(session_t *ps, struct win *w) {
 	}
 
 	if (w->managed) {
-		// Clear PIXMAP_STALE flag, since the window is destroyed there is no
-		// pixmap available so STALE doesn't make sense.
+		// Clear IMAGES_STALE flags since the window is destroyed:
+		//  - PIXMAP_STALE: as there is no pixmap available, STALE doesn't make
+		//  sense.
+		//  - SHADOW_STALE: recreating the shadow image doesn't make sense.
 		// Do this before changing the window state to destroying
-		win_clear_flags(mw, WIN_FLAGS_PIXMAP_STALE);
+		win_clear_flags(mw, WIN_FLAGS_IMAGES_STALE);
 
 		// Update state flags of a managed window
 		mw->state = WSTATE_DESTROYING;
@@ -1943,9 +1945,10 @@ void unmap_win_start(session_t *ps, struct managed_win *w) {
 	w->opacity_target_old = fmax(w->opacity_target, w->opacity_target_old);
 	w->opacity_target = win_calc_opacity_target(ps, w);
 
-	// Clear PIXMAP_STALE flag, since the window is unmapped there is no pixmap
-	// available so STALE doesn't make sense.
-	win_clear_flags(w, WIN_FLAGS_PIXMAP_STALE);
+	// Clear IMAGES_STALE flags since the window is unmapped:
+	//  - PIXMAP_STALE: as there is no pixmap available, STALE doesn't make sense.
+	//  - SHADOW_STALE: recreating the shadow image doesn't make sense.
+	win_clear_flags(w, WIN_FLAGS_IMAGES_STALE);
 
 	// don't care about properties anymore
 	win_ev_stop(ps, &w->base);
